---
title: Equality (==)
slug: Web/JavaScript/Reference/Operators/Equality
tags:
  - JavaScript
  - Language feature
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p>The equality operator (<code>==</code>) checks whether its two operands are equal, returning a Boolean result. Unlike the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Strict_equality">strict equality</a> operator, it attempts to convert and compare operands that are of different types.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-equality.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">x == y
</pre>

<h2 id="Description">Description</h2>

<p>The equality operators (<code>==</code> and <code>!=</code>) use the <a href="http://www.ecma-international.org/ecma-262/5.1/#sec-11.9.3">Abstract Equality Comparison Algorithm</a> to compare two operands. This can be roughly summarised as follows:</p>

<ul>
 <li>If the operands are both objects, return <code>true</code> only if both operands reference the same object.</li>
 <li>If one operand is <code>null</code> and the other is <code>undefined</code>, return <code>true</code>.</li>
 <li>If the operands are of different types, try to convert them to the same type before comparing:
  <ul>
   <li>When comparing a number to a string, try to convert the string to a numeric value.</li>
   <li>If one of the operands is <code>Boolean</code>, convert the Boolean operand to 1 if it is <code>true</code> and +0 if it is <code>false</code>.</li>
   <li>If one of the operands is an object and the other is a number or a string, try to convert the object to a primitive using the object's <code>valueOf()</code> and <code>toString()</code> methods.</li>
  </ul>
 </li>
 <li>If the operands have the same type, they are compared as follows:
  <ul>
   <li><code>String</code>: return <code>true</code> only if both operands have the same characters in the same order.</li>
   <li><code>Number</code>: return <code>true</code> only if both operands have the same value. <code>+0</code> and <code>-0</code> are treated as the same value. If either operand is <code>NaN</code>, return <code>false</code>.</li>
   <li><code>Boolean</code>: return <code>true</code> only if operands are both <code>true</code> or both <code>false</code>.</li>
  </ul>
 </li>
</ul>

<p>The most notable difference between this operator and the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Strict_equality">strict equality</a> (<code>===</code>) operator is that the strict equality operator does not attempt type conversion. Instead, the strict equality operator always considers operands of different types to be different.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Comparison_with_no_type_conversion">Comparison with no type conversion</h3>

<pre class="brush: js notranslate">1 == 1;              // true
"hello" == "hello";  // true</pre>

<h3 id="Comparison_with_type_conversion">Comparison with type conversion</h3>

<pre class="brush: js notranslate">"1" ==  1;            // true
1 == "1";             // true
0 == false;           // true
0 == null;            // false
0 == undefined;       // false
0 == !!null;          // true, look at Logical NOT operator
0 == !!undefined;     // true, look at Logical NOT operator
null == undefined;    // true

const number1 = new Number(3);
const number2 = new Number(3);
number1 == 3;         // true
number1 == number2;   // false</pre>

<h3 id="Comparison_of_objects">Comparison of objects</h3>

<pre class="brush: js notranslate">const object1 = {"key": "value"}
const object2 = {"key": "value"};

object1 == object2 // false
object2 == object2 // true</pre>

<h3 id="Comparing_strings_and_String_objects">Comparing strings and String objects</h3>

<p>Note that strings constructed using <code>new String()</code> are objects. If you compare one of these with a string literal, the <code>String</code> object will be converted to a string literal and the contents will be compared. However, if both operands are <code>String</code> objects, then they are compared as objects and must reference the same object for comparison to succeed:</p>

<pre class="brush: js notranslate">const string1 = "hello";
const string2 = String("hello");
const string3 = new String("hello");
const string4 = new String("hello");

console.log(string1 == string2); // true
console.log(string1 == string3); // true
console.log(string2 == string3); // true
console.log(string3 == string4); // false
console.log(string4 == string4); // true</pre>

<h3 id="Comparing_Dates_and_strings">Comparing Dates and strings</h3>

<pre class="brush: js notranslate">const d = new Date('December 17, 1995 03:24:00');
const s = d.toString(); // for example: "Sun Dec 17 1995 03:24:00 GMT-0800 (Pacific Standard Time)"
console.log(d == s);    //true</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-equality-operators', 'Equality operators')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.equality")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Inequality">Inequality operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Strict_equality">Strict equality operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Strict_inequality">Strict inequality operator</a></li>
</ul>
